#!/bin/bash

#$Id: knoerre-install.sh 691 2017-06-04 23:12:04Z fwbergm $

test -z "$PACKAGEHOME" && PACKAGEHOME=usr/local/package
test -z "$NAGIOSFWBHOME" && NAGIOSFWBHOME=opt/nagios-fwb
test -z "$NAGIOSFWBVAR" && NAGIOSFWBVAR=var/opt/nagios-fwb
test -z "$KNOERREHOME" && KNOERREHOME=$NAGIOSFWBHOME/knoerre
test -z "$KNOERREVAR" && KNOERREVAR=$NAGIOSFWBVAR/knoerre
test -z "$DESTDIR" && DESTDIR=/

export NAGIOSFWBHOME
export NAGIOSFWBVAR
export KNOERREHOME
export KNOERREVAR
# DESTDIR should end with /
#export DESTDIR=/home/vmaster/webserver_install-FWB/
export DESTDIR

CP=/bin/cp
RM=/bin/rm
MV=/bin/mv
LN=/bin/ln
INSTALL=/usr/bin/install

# nagios-fwb
echo "installing nagios-fwb"
test -f knoerre/knoerre || { echo "ERROR: knoerre/knoerre not found, wrong working dir?"; exit 31; }
#cd package/host/tuxad.com/nagios-fwb || { echo 'ERROR: dir package/host/tuxad.com/nagios-fwb does not exist'; exit 31; }
mkdir -p $DESTDIR/usr/local/share/man/man1 $DESTDIR/usr/local/sbin $DESTDIR/$NAGIOSFWBHOME/bin $DESTDIR/$NAGIOSFWBHOME/man/man1 $DESTDIR/$KNOERREVAR/log
for f in \
  knoerre/knoerre \
  knoerre/knoerre-conf \
  knoerre/knoerre-update-tcprules \
  plugins/check_remote_by_http \
  nagios-checks/nagios-check-backup \
  nagios-checks/nagios-check-diskfree \
  nagios-checks/nagios-check-longuserprocesses \
  nagios-checks/nagios-check-nfs \
  nagios-checks/nagios-check-process \
  nagios-checks/postfix-mailqsize \
  pyrre/pyrre.py \
  tools/daemonize \
  tools/direntries \
  tools/sstrip \
  tools/testcgi
do
  #loadlogger/loadlogger \
  $INSTALL -o root -g root -m 755 -p "$f" $DESTDIR/$NAGIOSFWBHOME/bin/ 2>/dev/null
  $INSTALL -o root -g root -m 755 -p "$f" $DESTDIR/usr/local/sbin/ 2>/dev/null
  #$LN -s /$NAGIOSFWBHOME/bin/$f $DESTDIR/usr/local/sbin/$f
done
gzip -d */*.1.gz 2>/dev/null
gzip -9 */*.1 2>/dev/null
$INSTALL -o root -g root -m 644 -p */*.1.gz $DESTDIR/usr/local/share/man/man1/ 2>/dev/null
$INSTALL -o root -g root -m 644 -p */*.1.gz $DESTDIR/$NAGIOSFWBHOME/man/man1/ 2>/dev/null
gzip -d */*.1.gz 2>/dev/null
$RM -f /service/knoerre/log/run /service/knoerre/run
knoerre/knoerre-conf
#pyrre/pyrre-conf.sh
