#ifdef KNOERRED
#include "knoerred.h"
#else
#include "knoerre.h"
#endif

/**
 * Return pointer to the char after the next separator in a string or NULL.
 *
 * Multiple consecutive occurences of the separator will count as one.
 *
 * @param p The string to be searched
 * @param sep The separator to be searched for.
 * @return The pointer to char after next sep in p or NULL.
 */
char *next_token(register char *p, register const char sep) {
  for (;;) {
    if (!*p) return 0; if (*p == sep) { ++p; for (;*p == sep; ++p); return p; } ++p;
    if (!*p) return 0; if (*p == sep) { ++p; for (;*p == sep; ++p); return p; } ++p;
    if (!*p) return 0; if (*p == sep) { ++p; for (;*p == sep; ++p); return p; } ++p;
    if (!*p) return 0; if (*p == sep) { ++p; for (;*p == sep; ++p); return p; } ++p;
  }
  return p;
}
