#include "buffer.h"

/**
 * $Id: buffer_getchar.c 691 2017-06-04 23:12:04Z fwbergm $
 */

int buffer_getchar(buffer *b) {
  register char *p;
  register ssize_t l;

  if (!b) return EOF;
  p = b->c;
  if (!p) return EOF;
  if (p < b->t) goto get;

  p = b->s;
  l = read(b->fd, p, b->l);
  if (l == 0) {
    b->c = b->t; /* EOF */
    return EOF;
  }
  if (l < 0) {
    b->c = b->t; /* like EOF */
    return -2;
  }
  b->t = p + l;

  get:
  b->c = p + 1;
  return (int) (unsigned char) (*p);
}
