#include "buffer.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

/**
 * $Id: buffer_openwrite.c 691 2017-06-04 23:12:04Z fwbergm $
 */

int buffer_openwrite(buffer *b, char *filename) {
  register int c = -1;

  if (!b) return c;
  if (!filename) return c;
  if (!*filename) return c;
  b->fd = c;
  b->c = b->s;
  b->l = 0;
  c = open(filename, O_WRONLY|O_CREAT|O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH );
  if (c == -1) return c;
  b->fd = c;
  return c;
}

