#include "buffer.h"

/**
 * $Id: buffer_putc.c 691 2017-06-04 23:12:04Z fwbergm $
 */

int buffer_putc(buffer *b, register const char a) {
  register char *p;
  register char *s;

  if (!b) return -1;
  p = b->c;
  if (p < b->t) goto put;

  s = b->s;
  if (write(b->fd, s, p - s) < 0) return -1;
  p = s;

  put:
  *p = a;
  ++p;
  b->c = p;
  return 0;
}
