#include <stdint.h>
#include <math.h>

double floor(double x) {
  volatile int64_t tmp;
  tmp = (int64_t) x;
  return (double) tmp;
}

double fmod(double x, double y) {
  volatile int64_t a,b;
  a = (int64_t) x;
  b = (int64_t) y;
  return (double) (a % b);
}

double sin(double x) {
  volatile int a;
  int signflag = 1;
  a = ((int) (x * 90 / M_PI) % 360);
  if (a < 0) { a = 0 - a; signflag = -1; }
  if (a > 90) {
    if (a > 270) {
      a -= 360;
    } else {
      a = 180 - a;
    }
  }
  return signflag * (((double) a) / 90);
}

double cos(double x) { return sin(x + M_PI); }
double ceil(double x) { return floor(x) + 1; }
float ceilf(float x) { return (float) ceil(x); }

double exp(double x) { return 1; }
double atan(double x) { return 1; }
double atan2(double y, double x) { return 1; }
double log(double x) { return 1; }
double sqrt(double x) { return 1; }
