#include "../lib/libfwb.h"
#include <sys/syscall.h>
#include <errno.h>
#include <sys/types.h>

int setgid32m(gid32_t gid32) {
#if defined __NR_setgid32
  int res = syscall(__NR_setgid32, gid32);
  if (res == -1 && errno == ENOSYS) { /* 38 */
    res = syscall(__NR_setgid, (uint16_t) gid32);
  }
  return res;
#else
  return syscall(__NR_setgid, gid32);
#endif
}
