#include "../lib/libfwb.h"
#include <sys/syscall.h>
#include <errno.h>
#include <sys/types.h>

int setresgid32m(gid32_t rgid, gid32_t egid, gid32_t sgid) {
#if defined __NR_setresgid32
  int res = syscall(__NR_setresgid32, rgid, egid, sgid);
  if (res == -1 && errno == ENOSYS) { /* 38 */
    res = syscall(__NR_setresgid, rgid, egid, sgid);
  }
  return res;
#else
  return syscall(__NR_setresgid, rgid, egid, sgid);
#endif
}
