#include "../lib/libfwb.h"
#include <sys/syscall.h>
#include <errno.h>
#include <sys/types.h>

int setresuid32m(uid32_t ruid, uid32_t euid, uid32_t suid) {
#if defined __NR_setresuid32
  int res = syscall(__NR_setresuid32, ruid, euid, suid);
  if (res == -1 && errno == ENOSYS) { /* 38 */
    res = syscall(__NR_setresuid, ruid, euid, suid);
  }
  return res;
#else
  return syscall(__NR_setresuid, ruid, euid, suid);
#endif
}
