#include "libfwb.h"

/**
 * Return the first position of a char in a string.
 *
 * The given string is searched for the first occurence of the given char.
 * If the char is not found then -1 will be returned.
 *
 * $Id: str_chr.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @param in The String to be searched.
 * @param needle The char to be searched for.
 * @return The index of the first char or -1 if not found.
 */
int32_t str_chr(const char *in, register char needle) {
  register const char* t = in;

  if (!in) return -1;
  for (;;) {
    if (!*t) return -1; if (*t == needle) break; ++t;
    if (!*t) return -1; if (*t == needle) break; ++t;
    if (!*t) return -1; if (*t == needle) break; ++t;
    if (!*t) return -1; if (*t == needle) break; ++t;
    if (!*t) return -1; if (*t == needle) break; ++t;
    if (!*t) return -1; if (*t == needle) break; ++t;
    if (!*t) return -1; if (*t == needle) break; ++t;
    if (!*t) return -1; if (*t == needle) break; ++t;
  }
  return (int32_t) (t - in);
}
