# based on dietlibc-0.32
# FWB 2009-06-16
# str_chrnul() like GNU strchrnul()
# $Id: str_chrnul.S 691 2017-06-04 23:12:04Z fwbergm $
# @param t The string to search in.
# @param c The char to search for.
# @return Pointer to the first char c or to NULL-byte.

.text
.type   str_chrnul,@function
.global str_chrnul
.weak index
.type index,@function

index:
str_chrnul:
	movl	4(%esp),%ecx
	movb	8(%esp),%dl
.Lloop:
	movb	(%ecx),%al
	cmpb	%al,%dl
	jz .Lfound
	incl	%ecx
	testb	%al,%al
	jnz .Lloop
.Lfound:
	movl	%ecx,%eax
	ret
