#include "libfwb.h"

/**
 * str_chrnul() like GNU strchrnul()
 *
 * $Id: str_chrnul.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @param t The string to search in.
 * @param c The char to search for.
 * @return Pointer to the first char c or to NULL-byte.
 */
char *str_chrnul(register char* t, register char c) {
  if (!t) return 0;
  for (;;) {
    if (*t == c) break; if (!*t) break; ++t;
    if (*t == c) break; if (!*t) break; ++t;
    if (*t == c) break; if (!*t) break; ++t;
    if (*t == c) break; if (!*t) break; ++t;
    if (*t == c) break; if (!*t) break; ++t;
    if (*t == c) break; if (!*t) break; ++t;
    if (*t == c) break; if (!*t) break; ++t;
    if (*t == c) break; if (!*t) break; ++t;
  }
  return t;
}
