#include "libfwb.h"

/**
 * Return end position of a string in a string.
 *
 * This is a helper function for do_check_longuserprocesses.
 *
 * $Id: str_index2.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @param a The string to be searched through.
 * @param b The string to be searched for.
 * @return The end position of the second string or -1 if not found.
 */
int32_t str_index2(const char* a, const char* b) {
  register const char* s;
  register char z;
  register const char* u;
  register int32_t t;

  if ((!a) || (!b)) return -1;
  s = a;
  t = strlen(b);
  u = s + strlen(s) - t;
  z = *b;
  for (;;) {
    if (s > u) break; if ((*s == z) && (!strncmp(s, b, t))) return (s - a) + t; ++s;
    if (s > u) break; if ((*s == z) && (!strncmp(s, b, t))) return (s - a) + t; ++s;
    if (s > u) break; if ((*s == z) && (!strncmp(s, b, t))) return (s - a) + t; ++s;
    if (s > u) break; if ((*s == z) && (!strncmp(s, b, t))) return (s - a) + t; ++s;
  }
  return -1;
}
