#include "monitoringfs.h"

KD *search_kd_entry(const char *kdirpath, KD *start, int insert) {
  register char *p;
  KD *e;
  KD *last_entry;
  char dirpath[STRINGSIZE + 1];

  last_entry = 0;
  if (start) {
    e = start;
  } else {
    e = &keyroot;
  }
  p = (char *) kdirpath;

  p = strrchr(p, '/');
  if (p) {
    strncpy(dirpath, kdirpath, p - kdirpath);
    dirpath[p - kdirpath] = 0;
    e = search_kd_dir(dirpath, e, insert);
    if (!e) return 0;
    ++p;
  } else p = (char *) kdirpath;

  e = search_kd_direntry(p, e, &last_entry);
  if (!e) {
    if (insert) e = create_kd_entry(kdirpath);
    if (!e) return 0;
    last_entry->next = e;
  }
  return e;
}
