#!/bin/bash

# /etc/nagios-cache.d/nettraf.sh
# $Id: nettraf.sh 691 2017-06-04 23:12:04Z fwbergm $

# do some checks, set up environment, cd /nagios-cache :
test -e /etc/nagios-cache.d/.ncrc || { echo "ERROR: no /etc/nagios-cache.d/.ncrc found" | tee /dev/stderr; exit 1; }
. /etc/nagios-cache.d/.ncrc

KEY=nettraf/venet0
TMPSUFFIX=$(date +%M)
KEYDIR=${KEY%/*}
mkdir -p $KEYDIR 2>/dev/null
KEYRESULT=$KEY
[ -d "$KEYRESULT" ] && KEYRESULT="$KEYRESULT"_
LOCKFILE="$KEYRESULT".lock

for dev in eth0 eth1 venet0
do
  (
    #knoerre $KEYDIR/$dev/55 >>$KEYDIR/$dev.$TMPSUFFIX 2>/dev/null || echo 999999999999999999 >>$KEYDIR/$dev.$TMPSUFFIX
    #/bin/mv $KEYDIR/$dev.$TMPSUFFIX $KEYDIR/$dev 2>/dev/null
    if knoerre $KEYDIR/$dev/55 >>$KEYDIR/$dev.$TMPSUFFIX 2>/dev/null
    then
      /bin/mv $KEYDIR/$dev.$TMPSUFFIX $KEYDIR/$dev 2>/dev/null
    else
      /bin/rm -f $KEYDIR/$dev.$TMPSUFFIX
    fi
  )&
done


wait


exit 0
# STOP HERE !!!

