/*
 * nagios-check-diskfree.c
 * prints available space on a mounted fs
 * Frank Bergmann, 12/2007
 */

#include <unistd.h>
#include <sys/vfs.h>
#include "../lib/libfwb.h"

int main(int argc,char *const argv[]) {
  struct statfs stat_buf;
  register long s;

  if(argc<2) { write1("missing argument\n",17); goto error; }
  if(statfs(argv[1],&stat_buf)!=0) goto error;
  s=stat_buf.f_blocks/100;
  putlong((stat_buf.f_blocks-stat_buf.f_bavail)/s);
  /* putlong(stat_buf.f_bavail*stat_buf.f_bsize/1024); free 1k-blocks */
  _exit(0);

  error:
  putlong(9999);
  _exit(1);
}
