;
; procage.asm TESTING/DEVELOPMENT
; print age of process
; this asm-Version must be processed by "nasm -f bin" to produce a executable
; Frank Bergmann www.tuxad.com, 09/2016
; 

;        %include "lib/elfheader.asm"
; this asm-Version must be processed by "nasm -f elf" and linked with ld
section .text    ;section declaration

                 ;we must export the entry point to the ELF linker or
global _start    ;loader. They conventionally recognize _start as their
                 ;entry point. Use ld -e foo to override the default.
global _call
%include "lib/system.asm"

_start:
        jmp     errexit

        mov     eax,[esp]
        dec     eax
        jz      errexit
        mov     eax,[esp+8]
        push    eax
        call    strlen
        pop     ebx
        xchg    eax,ebx
        SYSTEM_exit

        mov     eax,'4'
        push    eax
        mov     eax,TESTSTR
        push    eax
_call:        call strchr
        pop     ebx
        pop     ebx
        or      eax,eax
        jnz     noerr
        dec     eax
        xchg    eax,ebx
        SYSTEM_exit
noerr        mov     ebx,TESTSTR
        sub     eax,ebx
        xchg    eax,ebx
        SYSTEM_exit
errexit mov     ebx,1
        SYSTEM_exit
strchr  mov     eax,[esp+4]
        mov     ecx,[esp+8]
strclp  cmp     [eax],cl
        jz      strend
        cmp     byte[eax],0
        jz      strcnf
        inc     eax
        jmp     strclp
strcnf  xor     eax,eax
strend  ret
strlen  mov     ecx,[esp+4]
        xor     eax,eax
        or      ecx,ecx
        jz      strend
strllp  cmp     byte[ecx],0
        jz      strend
        inc     eax
        inc     ecx
        jmp     strllp
strnum  mov     ecx,[esp+4]
        xor     eax,eax
        or      ecx,ecx
        jz      strend
        xor     edx,edx
strnlp  mov     edx,[ecx]
        cmp     edx,'0'
        jc      strend
        cmp     edx,'9'
        jnc     strend
        mul     eax,10
        add     eax,edx
        jmp     strnlp
strnm   mov     ecx,[esp+4]     ; string buffer
        mov     esi,[esp+8]     ; num
        xor     edx,edx
        mov     eax,"1000000000"
strnlp1 mov     ebx,eax
        mov     eax,esi
        div     eax,ebx
        or      eax,eax
        jnz     strn1st
        mov     eax,ebx
        div     eax,10
        or      eax,eax
        jnz     strnlp1
        mov     eax,'0'
        mov     [ecx],al
        xor     eax,eax
        mov     [ecx+1],al
        inc     eax
        ret
strn1st add     eax,'0'
        mov     [ecx],al
        inc     ecx
        sub     eax,'0'
        mul     eax,ebx
        sub     esi,eax
        mov     eax,ebx
        div     eax,10
        or      eax,eax
        jz      strnend

strnlp2 mov     ebx,eax
        mov     eax,esi
        div     eax,ebx
        or      eax,eax
        jnz     strn1st
strnend xor     eax,eax
        mov     [ecx],al
        mov     eax,ecx
        mov     ecx,[esp+4]
        sub     eax,ecx
        ret



numbuf  db      "4294967296",0
aa db "aa",0
TESTSTR db      "12345",0
xx db      "xx",0
        db      0

filesize    equ    $ - $$
