;
; shell-wrapper-linkwld.asm
; run program as a different user, need setuid bit set
; this asm-Version must be processed by "nasm -f elf" and linked with ld
; Frank Bergmann www.tuxad.com, 06/2015
; 

section .text    ;section declaration

                 ;we must export the entry point to the ELF linker or
global _start    ;loader. They conventionally recognize _start as their
                 ;entry point. Use ld -e foo to override the default.

_start:

        ; remove this block if you just need the EUID set
        mov     eax,49
        int     0x80          ; geteuid()
        mov     ebx,eax
        mov     ecx,-1
        mov     eax,70
        int     0x80          ; setreuid(geteuid(),-1)

        lea     ecx,[esp+8]   ; execve(argv[1],argv+1,0);
        mov     ebx,[ecx]
        xor     edx, edx
        xor     eax,eax
        mov     al,11
        int     0x80

        mov     ebx,111       ;error on exec: return 111
        xor     eax, eax
        inc     eax           ;_exit()
        int     0x80

section .data    ;section declaration
