/*
 * shell-wrapper
 * run a program as a different user, needs setgid bit set
 * Frank Bergmann www.tuxad.com, 06/2015
 */

#include <unistd.h>

int main(int argc,char *const argv[]) {
  setreuid(geteuid(),-1); /* remove it if you just need the EUID set */
  execve(argv[1],argv+1,0);
  _exit(111);
}
