#!/bin/bash

# This has to be a separate file from scripts/make.sh so it can be called
# before menuconfig.  (It's called again from scripts/make.sh just to be sure.)

mkdir -p generated

genconfig()
{
  # extract config stanzas from each command source file, in alphabetical order

  for i in $1/*.c
  do
    # Grab the config block for Config.in
    echo "# $i"
    sed -n '/^\*\//q;/^config [A-Z]/,$p' $i #|| return 1
    echo
  done
}

genconfig knoerre >generated/Config.in.knoerre||rm -f generated/Config.in.knoerre
genconfig tools >generated/Config.in.tools||rm -f generated/Config.in.tools
