#include "buffer.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

/**
 * $Id: buffer_openread.c 691 2017-06-04 23:12:04Z fwbergm $
 */

int buffer_openread(buffer *b, const char *filename) {
  register int c = -1;

  if (!b) return c;
  if (!filename) return c;
  if (!*filename) return c;
  b->fd = c;
  b->t = b->s + b->l;
  b->c = b->t;
  c = open(filename, O_RDONLY);
  if (c == -1) return c;
  b->fd = c;
  return c;
}

