#include "../lib/libfwb.h"
#include <sys/syscall.h>
#include <errno.h>
#include <sys/types.h>

int fchown32m(int fd, uid32_t owner, gid32_t group) {
#if defined __NR_fchown32
  int res = syscall(__NR_fchown32, fd, owner, group);
  if (res == -1 && errno == ENOSYS) { /* 38 */
    res = syscall(__NR_fchown, fd, owner, group);
  }
  return res;
#else
  return syscall(__NR_fchown, fd, owner, group);
#endif
}
