#include "../lib/libfwb.h"
#include <sys/syscall.h>
#include <errno.h>
#include <sys/types.h>

uid32_t getuid32m() {
#if defined __NR_getuid32
  int res = syscall(__NR_getuid32);
  if (res == -1 && errno == ENOSYS) { /* 38 */
    res = syscall(__NR_getuid);
  }
  return (uid32_t) res;
#else
  return syscall(__NR_getuid);
#endif
}
