#include "../lib/libfwb.h"
#include <sys/syscall.h>
#include <errno.h>
#include <sys/types.h>

int setuid32m(uid32_t uid32) {
#if defined __NR_setuid32
  int res = syscall(__NR_setuid32, uid32);
  if (res == -1 && errno == ENOSYS) { /* 38 */
    res = syscall(__NR_setuid, (uint16_t) uid32);
  }
  return res;
#else
  return syscall(__NR_setuid, uid32);
#endif
}

