#include "libfwb.h"

/**
 * Write a uint64_t and a LF into a string buffer.
 *
 * WARNING: No boundary checks can be made!
 *
 * $Id: sputlongs.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @param buf The buffer to write the decimal number in.
 * @param num The number to write in the buffer.
 * @return The pointer to the string terminating null.
 */
char *sputlongs(char *buf, uint64_t num) {
  register char *pbuf;
  register int c,o;
  uint64_t i,d;

  if (!buf) return 0;
  i = num; o = 0;
  pbuf = buf;
  for (d = 10000000000000000000ULL; d > 1; d /= 10) {
    c = i / d;
    if ((c > 0) || (o)) {
      *pbuf = c + '0';
      ++pbuf;
      i = i - (c * d);
      o = 1;
    }
  }
  *pbuf = i + '0'; ++pbuf;
  *pbuf = '\n'; ++pbuf;
  *pbuf = 0;
  return pbuf;
}
