#include "libfwb.h"

/**
 * Append a char to a string.
 *
 * Append a char to a string without boundary checks.
 *
 * $Id: str_catc.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @param out The string to be grow.
 * @param c The char to be appended.
 * @return A pointer to the end of the string.
 */
char *str_catc(register char* out, register const char c) {
  if (!out) return 0;
  for (;;) {
    if (!*out) break; ++out;
    if (!*out) break; ++out;
    if (!*out) break; ++out;
    if (!*out) break; ++out;
  }
  *out = c; ++out;
  *out = 0;
  return out;
}
