#include "monitoringfs.h"

int bgetline(char *r, int size) {
  register char *p;
  register ssize_t l;

  p = buf0.c;
  if (!p) return EOF;
  if (p < buf0.t) goto get;

  p = buf0.s;
  l = read(0, p, buf0.l);
  if (l <= 0) {
    buf0.c = 0; /* EOF */
    if (l < 0) return -2;
    return EOF;
  }
  buf0.t = p + l;
  buf0.c = p;

  get:
  p = strchr(p, '\n');
  if (p) goto foundln;
  l = buf0.t - buf0.c;
  p = buf0.c;

  if (size < l) l = size;
  memcpy(r, p, l);
  buf0.c += l;
  r += l;
  *r = 0;
  if (size == l) return l;
  size -= l;
  int l2 = bgetline(r, size);
  if (l2 != EOF) l += l2;
  return l;

  foundln:
  ++p;
  l = p - buf0.c;
  if (size < l) l = size;
  memcpy(r, buf0.c, l);
  buf0.c += l;
  r += l;
  *r = 0;
  return l;
}
