#include "monitoringfs.h"

KD *create_kd_entry(const char *path) {
  register char *p;
  KD *kd;
  int len;

  if (!path) return 0;
  len = strlen(path);
  kd = alloc(sizeof(KD));
  if (!kd) return 0;
  p = alloc(len + 1);
  if (!p) return 0;
  strcpy(p, path);
  kd->fullpath = p;
  p = strrchr(kd->fullpath, '/');
  if (p) {
    ++p;
    kd->entry = p;
  } else {
    kd->entry = kd->fullpath;
  }
  kd->subdir = 0;
  kd->next = 0;
  kd->is_dir = 0;
  kd->lnk_count = 0;
  return kd;
}
