#include "monitoringfs.h"

KD *search_kd_direntry(const char *entry, KD *start, KD **last_entry) {
  KD *e;

  if (!start) return 0;
  if (!entry) return 0;
  e = start;
  for (;;) {
    if (!strcmp(e->entry, entry)) return e;
    if (last_entry) *last_entry = e;
    e = e->next;
    if (!e) return 0;
  }
  return 0;
}
