#include "monitoringfs.h"

KD *insert_kd_dir(KD *start, const char *fullpath, const char *entry) {
  register char *p;
  KD *kd;
  KD *sub;
  char tmpstring[STRINGSIZE + 4];

  if (!fullpath) return 0;
  if (!entry) return 0;
  if (!start) start = &keyroot;
  for (;;) {
    if (start->next) start = start->next;
    else break;
  }
  kd = create_kd_entry(fullpath);
  if (!kd) return 0;
  p = stpcpy(tmpstring, fullpath);
  p = stpcpy(p, "/.");
  sub = create_kd_entry(tmpstring);
  if (!sub) return 0;
  sub->is_dir = 1;
  kd->subdir = sub;
  *p = '.'; ++p; *p = 0;
  start->next = kd;
  kd = create_kd_entry(tmpstring);
  if (!kd) return 0;
  kd->is_dir = 1;
  sub->next = kd;
  return start->next;
}
