#!/bin/bash

# /etc/nagios-cache.d/cpuidle.sh
# $Id: cpuidle.sh 691 2017-06-04 23:12:04Z fwbergm $
# long running idle check

test -e /etc/nagios-cache.d/.ncrc || { echo "ERROR: no /etc/nagios-cache.d/.ncrc found" | tee /dev/stderr; exit 1; }
. /etc/nagios-cache.d/.ncrc

MINUTES=15
SECONDS=$(( ($MINUTES * 60) - 5 ))
KEY=cpuic/$SECONDS
TMPSUFFIX=$(date +%M)

mkdir -p cpuic 2>/dev/null
knoerre $KEY >>$KEY.$TMPSUFFIX 2>/dev/null
/bin/mv $KEY.$TMPSUFFIX $KEY 2>/dev/null

