#!/bin/bash

# /etc/nagios-cache.d/easyraid.sh
# $Id: easyraid.sh 691 2017-06-04 23:12:04Z fwbergm $

# do some checks, set up environment, cd /nagios-cache :
test -e /etc/nagios-cache.d/.ncrc || { echo "ERROR: no /etc/nagios-cache.d/.ncrc found" | tee /dev/stderr; exit 1; }
. /etc/nagios-cache.d/.ncrc

mkdir -p check_easyraid
for f in $(find /etc/nagios*/mittwald/san -type f |grep "easyraid.cfg$"|sed 's,/services/.*,,')
do
  IP=$(grep "^[	 ]*address" $f/host.cfg|awk '{print$2}')
  /usr/local/nagios/libexec/check_easyraid.pl $IP >>check_easyraid/$IP.0 2>&1 || \
    /usr/local/nagios/libexec/check_easyraid.pl $IP >>check_easyraid/$IP.0 2>&1
  /bin/mv check_easyraid/$IP.0 check_easyraid/$IP 2>/dev/null
done
