#!/bin/bash

test -e /etc/nagios-cache.d/.ncrc || { echo "ERROR: no /etc/nagios-cache.d/.ncrc found" | tee /dev/stderr; exit 1; }
. /etc/nagios-cache.d/.ncrc

KEY=filesizesbysuffix/.ibd/1/var/lib/mysql
KEYDIR=${KEY%/*}

mkdir -p $KEYDIR 2>/dev/null

knoerre $KEY >>$KEY.0 2>/dev/null
RET=$?
/bin/mv $KEY.0 $KEY 2>/dev/null

exit $RET
