%global _hardened_build 1

%if 0%{?_with_diet:1}
%define diet 1
%else
%define diet 0
%endif

Summary: tools useful for deploying the PIM
Name: pimtools
Version: 20150703
Release: 1%{?_with_diet:diet}%{?dist}
Source0: %{name}-%{version}.tgz
#Source1: %{name}-%{version}.tgz.asc
License: GPL v2
Group: Admin
URL: http://www.tuxad.de/
BuildRoot: %{_tmppath}/buildroot-%{name}-%{version}
BuildRequires: nasm
%if %diet
BuildRequires: dietlibc
%endif

%description 	
The pimtools are some small tools useful for deploying the PIM.

rpmbuild options:
--with diet (build with dietlibc, diet must be in PATH)


%prep
%setup -q
make distclean


%build
%if %diet
make OPTFLAGS="%{optflags}"
%else
make DIET="" OPTFLAGS="%{optflags}"
%endif


%install
[ -d  ${RPM_BUILD_ROOT} -a "${RPM_BUILD_ROOT}" != "/" ] && rm -rf  ${RPM_BUILD_ROOT}
%if %diet
%makeinstall DESTDIR=${RPM_BUILD_ROOT} OPTFLAGS="%{optflags}"
%else
%makeinstall DESTDIR=${RPM_BUILD_ROOT} DIET="" OPTFLAGS="%{optflags}"
%endif


%clean
[ -d  ${RPM_BUILD_ROOT} -a "${RPM_BUILD_ROOT}" != "/" ] && rm -rf  ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root,-)
%doc README INSTALL COPYING CHANGELOG pimtools.spec .config
%doc doc/pimtools-overview.dot doc/pimtools-overview.png doc/pimtools-quickstart-de.pdf doc/pimtools-quickstart-de.txt
%_bindir/check-nfs
%_bindir/chownu
%_bindir/user-wrapper
%_mandir/man1/check-nfs.1.*
%_mandir/man1/chownu.1.*
%_mandir/man1/user-wrapper.1.*


%changelog
* Fri Jul 03 2015 Frank Bergmann <http://www.tuxad.com/> 20150703-1
- initial version
