#!/bin/sh

# FWB 2012-06-27:
# replacement of check_diskusagelocal as script for Darwin and more
# don't blame me for this ugly mix of awk and bash, it's a quick hack

# defaults
WARN=70
CRIT=80

while [ "$1" ]
do
  if [ "$1" = "-w" ]
  then
    shift
    WARN=$1
  else
    if [ "$1" = "-c" ]
    then
      shift
      CRIT=$1
    fi
  fi
  shift
done
export WARN
export CRIT
#echo $WARN $CRIT

export LANG=C
df -l -k|awk '$1!="Filesystem"{
    lastdev=dev
    dev=$1
    total=$2
    used=$3
    avail=$4
    percent=$5
    mp=$6
    if ($6=="")
    {
      total=$1
      used=$2
      avail=$3
      percent=$4
      mp=$5
      if ($2!="") dev=lastdev
    }
    if (percent!="") print substr(percent,0,length(percent)-1)" "dev" "total/1024/1024" "used/1024/1024" "avail/1024/1024" "percent" "mp
  }'|sort -n|tail -n 1 \
|{
  read PERCENT DEV TOTAL USED AVAIL PERCENTUNIT MP
  if [ $PERCENT -gt $CRIT ]
  then
    echo "DISK CRITICAL - $PERCENT ($MP $TOTAL/$USED/$AVAIL GB)| disk=$PERCENT;$WARN;$CRIT"
    exit 2
  fi
  if [ $PERCENT -gt $WARN ]
  then
    echo "DISK WARNING - $PERCENT ($MP $TOTAL/$USED/$AVAIL GB)| disk=$PERCENT;$WARN;$CRIT"
    exit 1
  fi
  echo "DISK OK - $PERCENT | disk=$PERCENT;$WARN;$CRIT"
  exit 0
}
