#include <sys/types.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

int main(int argc,char *const argv[]) {
  register pid_t child_pid;
  register int c;
  int child_status;
  const char child_exec_path[]="/usr/local/nagios/libexec/check_remote_by_http";
  const char *child_exec_args[]={ \
    "/usr/local/nagios/libexec/check_remote_by_http", \
    "-w", \
    "22", \
    "-c", \
    "28", \
    "-H", \
    argv[1], \
    "-p", \
    "8488", \
    "load1", \
    0
  };

  if (argc!=2) return 3;
  for(c=0;c<5000;c++) {
    if ((child_pid=fork())<0) return 1;
    if (child_pid==0) { /* child */
      close(1);
      execve(child_exec_path,(char*const*) child_exec_args, NULL);
      return 2;
    }
    wait(&child_status);
  }
  return 0;
}


