#include "griller.h"

uint32_t get_load1() {
  register char *p;
  int i;
  ssize_t s;
  char loadavg[STRING_SIZE+1];
  uint32_t load1;

  i = open("/proc/loadavg", O_RDONLY);
  if (__unlikely(i < 0)) return 1;
  p = loadavg;
  s = read(i, p, STRING_SIZE);
  close(i);
  if (__unlikely(s < 2)) return 1;
  if(!str2uint32(loadavg, &load1)) return 1;
  return load1;
}

int is_socket_link(register const char *s) {
  if (*s != 's') return 0;
  if (*++s != 'o') return 0;
  if (*++s != 'c') return 0;
  if (*++s != 'k') return 0;
  if (*++s != 'e') return 0;
  if (*++s != 't') return 0;
  if (*++s != ':') return 0;
  return 1;
}
