#!/usr/bin/python
import sys,os,time
import xmpp

if len(sys.argv) < 4:
    print "Syntax: nagios-to-xmpp-muc.py muc-jid nick message"
    sys.exit(0)

muc = sys.argv[1]
nick = sys.argv[2]
msgtext = sys.argv[3]

server = muc.split("@")[1]
conn  = xmpp.Client(server, debug=[])
if not conn.connect():
    # try to strip first part, maybe "conference."
    server = server.split(".",1)[1]
    conn  = xmpp.Client(server, debug=[])
    if not conn.connect():
        print 'Error on connect()'
        sys.exit(1)

anonymous = conn.auth(None, '')
if not anonymous:
    print 'Error on anoynous auth()'
    sys.exit(2)
  
conn.send(xmpp.Presence(to="%s/%s" % (muc, nick)))
msg = xmpp.protocol.Message(body=msgtext)
msg.setTo(muc)
msg.setType('groupchat')
if not conn.send(msg):
    print 'Error sending message'
    sys.exit(3)
